diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/wifi-phy.cc ns-3.32/src/wifi/model/wifi-phy.cc
--- ns-3.31/src/wifi/model/wifi-phy.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/wifi-phy.cc	2020-10-06 15:35:43.000000000 -0700
@@ -618,100 +736,6 @@
 }
 
 void
-WifiPhy::SetGreenfield (bool greenfield)
-{
-  NS_LOG_FUNCTION (this << greenfield);
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-  if (device)
-    {
-      Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration ();
-      if (htConfiguration)
-        {
-          htConfiguration->SetGreenfieldSupported (greenfield);
-        }
-    }
-  m_greenfield = greenfield;
-}
-
-bool
-WifiPhy::GetGreenfield (void) const
-{
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-  if (device)
-    {
-      Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration ();
-      if (htConfiguration)
-        {
-          return htConfiguration->GetGreenfieldSupported ();
-        }
-    }
-  return m_greenfield;
-}
-
-void
-WifiPhy::SetShortGuardInterval (bool shortGuardInterval)
-{
-  NS_LOG_FUNCTION (this << shortGuardInterval);
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-  if (device)
-    {
-      Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration ();
-      if (htConfiguration)
-        {
-          htConfiguration->SetShortGuardIntervalSupported (shortGuardInterval);
-        }
-    }
-  m_shortGuardInterval = shortGuardInterval;
-}
-
-bool
-WifiPhy::GetShortGuardInterval (void) const
-{
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-  if (device)
-    {
-      Ptr<HtConfiguration> htConfiguration = device->GetHtConfiguration ();
-      if (htConfiguration)
-        {
-          return htConfiguration->GetShortGuardIntervalSupported ();
-        }
-    }
-  return m_shortGuardInterval;
-}
-
-void
-WifiPhy::SetGuardInterval (Time guardInterval)
-{
-  NS_LOG_FUNCTION (this << guardInterval);
-  NS_ASSERT (guardInterval == NanoSeconds (800) || guardInterval == NanoSeconds (1600) || guardInterval == NanoSeconds (3200));
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-  if (device)
-    {
-      Ptr<HeConfiguration> heConfiguration = device->GetHeConfiguration ();
-      if (heConfiguration)
-        {
-          heConfiguration->SetGuardInterval (guardInterval);
-        }
-    }
-  m_guardInterval = guardInterval;
-}
-
-Time
-WifiPhy::GetGuardInterval (void) const
-{
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (GetDevice ());
-  if (device)
-    {
-      Ptr<HeConfiguration> heConfiguration = device->GetHeConfiguration ();
-      if (heConfiguration)
-        {
-          return heConfiguration->GetGuardInterval ();
-        }
-    }
-  return m_guardInterval;
-}
-
-void
 WifiPhy::SetShortPhyPreambleSupported (bool enable)
 {
   NS_LOG_FUNCTION (this << enable);
@@ -728,18 +752,6 @@
 WifiPhy::SetDevice (const Ptr<NetDevice> device)
 {
   m_device = device;
-  //TODO: to be removed once deprecated API is cleaned up
-  Ptr<HtConfiguration> htConfiguration = DynamicCast<WifiNetDevice> (device)->GetHtConfiguration ();
-  if (htConfiguration)
-    {
-      htConfiguration->SetShortGuardIntervalSupported (m_shortGuardInterval);
-      htConfiguration->SetGreenfieldSupported (m_greenfield);
-    }
-  Ptr<HeConfiguration> heConfiguration = DynamicCast<WifiNetDevice> (device)->GetHeConfiguration ();
-  if (heConfiguration)
-    {
-      heConfiguration->SetGuardInterval (m_guardInterval);
-    }
 }
 
 Ptr<NetDevice>
@@ -830,10 +842,10 @@
 }
 
 void
-WifiPhy::ConfigureDefaultsForStandard (WifiPhyStandard standard)
+WifiPhy::ConfigureDefaultsForStandard (void)
 {
-  NS_LOG_FUNCTION (this << standard);
-  switch (standard)
+  NS_LOG_FUNCTION (this);
+  switch (m_standard)
     {
     case WIFI_PHY_STANDARD_80211a:
       SetChannelWidth (20);
@@ -853,17 +865,14 @@
       // Channel number should be aligned by SetFrequency () to 1
       NS_ASSERT (GetChannelNumber () == 1);
       break;
-    case WIFI_PHY_STANDARD_80211_10MHZ:
-      SetChannelWidth (10);
-      SetFrequency (5860);
-      // Channel number should be aligned by SetFrequency () to 172
-      NS_ASSERT (GetChannelNumber () == 172);
-      break;
-    case WIFI_PHY_STANDARD_80211_5MHZ:
-      SetChannelWidth (5);
+    case WIFI_PHY_STANDARD_80211p:
+      if (GetChannelWidth () > 10)
+        {
+          SetChannelWidth (10);
+        }
       SetFrequency (5860);
-      // Channel number should be aligned by SetFrequency () to 0
-      NS_ASSERT (GetChannelNumber () == 0);
+      // Channel number should be aligned by SetFrequency () to either 172 or 171
+      NS_ASSERT ((GetChannelWidth () == 10 && GetChannelNumber () == 172) || (GetChannelWidth () == 5 && GetChannelNumber () == 171)) ;
       break;
     case WIFI_PHY_STANDARD_holland:
       SetChannelWidth (20);
@@ -871,17 +880,24 @@
       // Channel number should be aligned by SetFrequency () to 36
       NS_ASSERT (GetChannelNumber () == 36);
       break;
-    case WIFI_PHY_STANDARD_80211n_2_4GHZ:
+    case WIFI_PHY_STANDARD_80211n:
       SetChannelWidth (20);
-      SetFrequency (2412);
-      // Channel number should be aligned by SetFrequency () to 1
-      NS_ASSERT (GetChannelNumber () == 1);
-      break;
-    case WIFI_PHY_STANDARD_80211n_5GHZ:
-      SetChannelWidth (20);
-      SetFrequency (5180);
-      // Channel number should be aligned by SetFrequency () to 36
-      NS_ASSERT (GetChannelNumber () == 36);
+      if (m_band == WIFI_PHY_BAND_2_4GHZ)
+        {
+          SetFrequency (2412);
+          // Channel number should be aligned by SetFrequency () to 1
+          NS_ASSERT (GetChannelNumber () == 1);
+        }
+      else if (m_band == WIFI_PHY_BAND_5GHZ)
+        {
+          SetFrequency (5180);
+          // Channel number should be aligned by SetFrequency () to 36
+          NS_ASSERT (GetChannelNumber () == 36);
+        }
+      else
+        {
+          NS_FATAL_ERROR ("Invalid band");
+        }
       break;
     case WIFI_PHY_STANDARD_80211ac:
       SetChannelWidth (80);
@@ -889,17 +905,32 @@
       // Channel number should be aligned by SetFrequency () to 42
       NS_ASSERT (GetChannelNumber () == 42);
       break;
-    case WIFI_PHY_STANDARD_80211ax_2_4GHZ:
-      SetChannelWidth (20);
-      SetFrequency (2412);
-      // Channel number should be aligned by SetFrequency () to 1
-      NS_ASSERT (GetChannelNumber () == 1);
-      break;
-    case WIFI_PHY_STANDARD_80211ax_5GHZ:
-      SetChannelWidth (80);
-      SetFrequency (5210);
-      // Channel number should be aligned by SetFrequency () to 42
-      NS_ASSERT (GetChannelNumber () == 42);
+    case WIFI_PHY_STANDARD_80211ax:
+      if (m_band == WIFI_PHY_BAND_2_4GHZ)
+        {
+          SetChannelWidth (20);
+          SetFrequency (2412);
+          // Channel number should be aligned by SetFrequency () to 1
+          NS_ASSERT (GetChannelNumber () == 1);
+        }
+      else if (m_band == WIFI_PHY_BAND_5GHZ)
+        {
+          SetChannelWidth (80);
+          SetFrequency (5210);
+          // Channel number should be aligned by SetFrequency () to 42
+          NS_ASSERT (GetChannelNumber () == 42);
+        }
+      else if (m_band == WIFI_PHY_BAND_6GHZ)
+        {
+          SetChannelWidth (80);
+          SetFrequency (5975);
+          // Channel number should be aligned by SetFrequency () to 7
+          NS_ASSERT (GetChannelNumber () == 7);
+        }
+      else
+        {
+          NS_FATAL_ERROR ("Invalid band");
+        }
       break;
     case WIFI_PHY_STANDARD_UNSPECIFIED:
     default:
@@ -909,10 +940,66 @@
 }
 
 void
+WifiPhy::SetSifs (Time sifs)
+{
+  m_sifs = sifs;
+}
+
+Time
+WifiPhy::GetSifs (void) const
+{
+  return m_sifs;
+}
+
+void
+WifiPhy::SetSlot (Time slot)
+{
+  m_slot = slot;
+}
+
+Time
+WifiPhy::GetSlot (void) const
+{
+  return m_slot;
+}
+
+void
+WifiPhy::SetPifs (Time pifs)
+{
+  m_pifs = pifs;
+}
+
+Time
+WifiPhy::GetPifs (void) const
+{
+  return m_pifs;
+}
+
+Time
+WifiPhy::GetAckTxTime (void) const
+{
+  return m_ackTxTime;
+}
+
+Time
+WifiPhy::GetBlockAckTxTime (void) const
+{
+  return m_blockAckTxTime;
+}
+
+void
 WifiPhy::Configure80211a (void)
 {
   NS_LOG_FUNCTION (this);
 
+  // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
+  SetSifs (MicroSeconds (16));
+  SetSlot (MicroSeconds (9));
+  SetPifs (GetSifs () + GetSlot ());
+  // See Table 10-5 "Determination of the EstimatedAckTxTime based on properties
+  // of the PPDU causing the EIFS" of 802.11-2016
+  m_ackTxTime = MicroSeconds (44);
+
   m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6Mbps ());
   m_deviceRateSet.push_back (WifiPhy::GetOfdmRate9Mbps ());
   m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12Mbps ());
@@ -928,6 +1015,14 @@
 {
   NS_LOG_FUNCTION (this);
 
+  // See Table 16-4 "HR/DSSS PHY characteristics" of 802.11-2016
+  SetSifs (MicroSeconds (10));
+  SetSlot (MicroSeconds (20));
+  SetPifs (GetSifs () + GetSlot ());
+  // See Table 10-5 "Determination of the EstimatedAckTxTime based on properties
+  // of the PPDU causing the EIFS" of 802.11-2016
+  m_ackTxTime = MicroSeconds (304);
+
   m_deviceRateSet.push_back (WifiPhy::GetDsssRate1Mbps ());
   m_deviceRateSet.push_back (WifiPhy::GetDsssRate2Mbps ());
   m_deviceRateSet.push_back (WifiPhy::GetDsssRate5_5Mbps ());
@@ -938,6 +1033,11 @@
 WifiPhy::Configure80211g (void)
 {
   NS_LOG_FUNCTION (this);
+  // See Table 18-5 "ERP characteristics" of 802.11-2016
+  // Slot time defaults to the "long slot time" of 20 us in the standard
+  // according to mixed 802.11b/g deployments.  Short slot time is enabled
+  // if the user sets the ShortSlotTimeSupported flag to true and when the BSS
+  // consists of only ERP STAs capable of supporting this option.
   Configure80211b ();
 
   m_deviceRateSet.push_back (WifiPhy::GetErpOfdmRate6Mbps ());
@@ -951,33 +1051,47 @@
 }
 
 void
-WifiPhy::Configure80211_10Mhz (void)
+WifiPhy::Configure80211p (void)
 {
   NS_LOG_FUNCTION (this);
-
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate3MbpsBW10MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate4_5MbpsBW10MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6MbpsBW10MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate9MbpsBW10MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12MbpsBW10MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate18MbpsBW10MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate24MbpsBW10MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate27MbpsBW10MHz ());
-}
-
-void
-WifiPhy::Configure80211_5Mhz (void)
-{
-  NS_LOG_FUNCTION (this);
-
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate1_5MbpsBW5MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate2_25MbpsBW5MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate3MbpsBW5MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate4_5MbpsBW5MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6MbpsBW5MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate9MbpsBW5MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12MbpsBW5MHz ());
-  m_deviceRateSet.push_back (WifiPhy::GetOfdmRate13_5MbpsBW5MHz ());
+  if (GetChannelWidth () == 10)
+    {
+      // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
+      SetSifs (MicroSeconds (32));
+      SetSlot (MicroSeconds (13));
+      SetPifs (GetSifs () + GetSlot ());
+      m_ackTxTime = MicroSeconds (88);
+
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate3MbpsBW10MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate4_5MbpsBW10MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6MbpsBW10MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate9MbpsBW10MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12MbpsBW10MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate18MbpsBW10MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate24MbpsBW10MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate27MbpsBW10MHz ());
+    }
+  else if (GetChannelWidth () == 5)
+    {
+      // See Table 17-21 "OFDM PHY characteristics" of 802.11-2016
+      SetSifs (MicroSeconds (64));
+      SetSlot (MicroSeconds (21));
+      SetPifs (GetSifs () + GetSlot ());
+      m_ackTxTime = MicroSeconds (176);
+
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate1_5MbpsBW5MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate2_25MbpsBW5MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate3MbpsBW5MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate4_5MbpsBW5MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6MbpsBW5MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate9MbpsBW5MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12MbpsBW5MHz ());
+      m_deviceRateSet.push_back (WifiPhy::GetOfdmRate13_5MbpsBW5MHz ());
+    }
+  else
+    {
+      NS_FATAL_ERROR ("802.11p configured with a wrong channel width!");
+    }
 }
 
 void
@@ -985,6 +1099,10 @@
 {
   NS_LOG_FUNCTION (this);
 
+  SetSifs (MicroSeconds (16));
+  SetSlot (MicroSeconds (9));
+  SetPifs (GetSifs () + GetSlot ());
+
   m_deviceRateSet.push_back (WifiPhy::GetOfdmRate6Mbps ());
   m_deviceRateSet.push_back (WifiPhy::GetOfdmRate12Mbps ());
   m_deviceRateSet.push_back (WifiPhy::GetOfdmRate18Mbps ());
@@ -1091,15 +1209,17 @@
 WifiPhy::Configure80211n (void)
 {
   NS_LOG_FUNCTION (this);
-  if (Is2_4Ghz (GetFrequency ()))
+  if (m_band == WIFI_PHY_BAND_2_4GHZ)
     {
-      Configure80211b ();
       Configure80211g ();
     }
-  if (Is5Ghz (GetFrequency ()))
+  else
     {
       Configure80211a ();
     }
+  // See Table 10-5 "Determination of the EstimatedAckTxTime based on properties
+  // of the PPDU causing the EIFS" of 802.11-2016
+  m_blockAckTxTime = MicroSeconds (68);
   m_bssMembershipSelectorSet.push_back (HT_PHY);
   ConfigureHtDeviceMcsSet ();
 }
@@ -1128,13 +1248,13 @@
 WifiPhy::Configure80211ax (void)
 {
   NS_LOG_FUNCTION (this);
-  if (Is5Ghz (GetFrequency ()))
+  if (m_band == WIFI_PHY_BAND_2_4GHZ)
     {
-      Configure80211ac ();
+      Configure80211n ();
     }
   else
     {
-      Configure80211n ();
+      Configure80211ac ();
     }
 
   PushMcs (WifiPhy::GetHeMcs0 ());
@@ -1154,10 +1274,10 @@
 }
 
 bool
-WifiPhy::DefineChannelNumber (uint8_t channelNumber, WifiPhyStandard standard, uint16_t frequency, uint16_t channelWidth)
+WifiPhy::DefineChannelNumber (uint8_t channelNumber, WifiPhyBand band, WifiPhyStandard standard, uint16_t frequency, uint16_t channelWidth)
 {
-  NS_LOG_FUNCTION (this << +channelNumber << standard << frequency << channelWidth);
-  ChannelNumberStandardPair p = std::make_pair (channelNumber, standard);
+  NS_LOG_FUNCTION (this << +channelNumber << band << standard << frequency << channelWidth);
+  ChannelNumberStandardPair p = std::make_pair (std::make_pair (channelNumber, band), standard);
   ChannelToFrequencyWidthMap::const_iterator it;
   it = m_channelToFrequencyWidth.find (p);
   if (it != m_channelToFrequencyWidth.end ())
@@ -1188,8 +1308,8 @@
     }
   if (found)
     {
-      NS_LOG_DEBUG ("Found, returning " << +it->first.first);
-      return (it->first.first);
+      NS_LOG_DEBUG ("Found, returning " << +it->first.first.first);
+      return (it->first.first.first);
     }
   else
     {
@@ -1199,9 +1319,9 @@
 }
 
 void
-WifiPhy::ConfigureChannelForStandard (WifiPhyStandard standard)
+WifiPhy::ConfigureChannelForStandard (void)
 {
-  NS_LOG_FUNCTION (this << standard);
+  NS_LOG_FUNCTION (this);
   // If the user has configured both Frequency and ChannelNumber, Frequency
   // takes precedence
   if (GetFrequency () != 0)
@@ -1228,12 +1348,12 @@
       // the unspecified standard, configure using the known values;
       // otherwise, this is a configuration error
       NS_LOG_DEBUG ("Configuring for channel number " << +GetChannelNumber ());
-      FrequencyWidthPair f = GetFrequencyWidthForChannelNumberStandard (GetChannelNumber (), standard);
+      FrequencyWidthPair f = GetFrequencyWidthForChannelNumberStandard (GetChannelNumber (), GetPhyBand (), GetPhyStandard ());
       if (f.first == 0)
         {
           // the specific pair of number/standard is not known
           NS_LOG_DEBUG ("Falling back to check WIFI_PHY_STANDARD_UNSPECIFIED");
-          f = GetFrequencyWidthForChannelNumberStandard (GetChannelNumber (), WIFI_PHY_STANDARD_UNSPECIFIED);
+          f = GetFrequencyWidthForChannelNumberStandard (GetChannelNumber (), GetPhyBand (), WIFI_PHY_STANDARD_UNSPECIFIED);
         }
       if (f.first == 0)
         {
@@ -1249,10 +1369,11 @@
 }
 
 void
-WifiPhy::ConfigureStandard (WifiPhyStandard standard)
+WifiPhy::ConfigureStandardAndBand (WifiPhyStandard standard, WifiPhyBand band)
 {
-  NS_LOG_FUNCTION (this << standard);
+  NS_LOG_FUNCTION (this << standard << band);
   m_standard = standard;
+  m_band = band;
   m_isConstructed = true;
   if (m_frequencyChannelNumberInitialized == false)
     {
@@ -1260,12 +1381,12 @@
     }
   if (GetFrequency () == 0 && GetChannelNumber () == 0)
     {
-      ConfigureDefaultsForStandard (standard);
+      ConfigureDefaultsForStandard ();
     }
   else
     {
       // The user has configured either (or both) Frequency or ChannelNumber
-      ConfigureChannelForStandard (standard);
+      ConfigureChannelForStandard ();
     }
   switch (standard)
     {
@@ -1278,24 +1399,19 @@
     case WIFI_PHY_STANDARD_80211g:
       Configure80211g ();
       break;
-    case WIFI_PHY_STANDARD_80211_10MHZ:
-      Configure80211_10Mhz ();
-      break;
-    case WIFI_PHY_STANDARD_80211_5MHZ:
-      Configure80211_5Mhz ();
+    case WIFI_PHY_STANDARD_80211p:
+      Configure80211p ();
       break;
     case WIFI_PHY_STANDARD_holland:
       ConfigureHolland ();
       break;
-    case WIFI_PHY_STANDARD_80211n_2_4GHZ:
-    case WIFI_PHY_STANDARD_80211n_5GHZ:
+    case WIFI_PHY_STANDARD_80211n:
       Configure80211n ();
       break;
     case WIFI_PHY_STANDARD_80211ac:
       Configure80211ac ();
       break;
-    case WIFI_PHY_STANDARD_80211ax_2_4GHZ:
-    case WIFI_PHY_STANDARD_80211ax_5GHZ:
+    case WIFI_PHY_STANDARD_80211ax:
       Configure80211ax ();
       break;
     case WIFI_PHY_STANDARD_UNSPECIFIED:
@@ -1305,8 +1421,15 @@
     }
 }
 
+WifiPhyBand
+WifiPhy::GetPhyBand (void) const
+{
+  return m_band;
+}
+
+
 WifiPhyStandard
-WifiPhy::GetStandard (void) const
+WifiPhy::GetPhyStandard (void) const
 {
   return m_standard;
 }
@@ -1479,9 +1602,9 @@
 }
 
 WifiPhy::FrequencyWidthPair
-WifiPhy::GetFrequencyWidthForChannelNumberStandard (uint8_t channelNumber, WifiPhyStandard standard) const
+WifiPhy::GetFrequencyWidthForChannelNumberStandard (uint8_t channelNumber, WifiPhyBand band, WifiPhyStandard standard) const
 {
-  ChannelNumberStandardPair p = std::make_pair (channelNumber, standard);
+  ChannelNumberStandardPair p = std::make_pair (std::make_pair (channelNumber, band), standard);
   FrequencyWidthPair f = m_channelToFrequencyWidth[p];
   return f;
 }
@@ -1512,12 +1635,11 @@
       return;
     }
 
-  // First make sure that the channel number is defined for the standard
-  // in use
-  FrequencyWidthPair f = GetFrequencyWidthForChannelNumberStandard (nch, GetStandard ());
+  // First make sure that the channel number is defined for the standard in use
+  FrequencyWidthPair f = GetFrequencyWidthForChannelNumberStandard (nch, GetPhyBand (), GetPhyStandard ());
   if (f.first == 0)
     {
-      f = GetFrequencyWidthForChannelNumberStandard (nch, WIFI_PHY_STANDARD_UNSPECIFIED);
+      f = GetFrequencyWidthForChannelNumberStandard (nch, GetPhyBand (), WIFI_PHY_STANDARD_UNSPECIFIED);
     }
   if (f.first != 0)
     {
@@ -2122,15 +2244,15 @@
 }
 
 Time
-WifiPhy::GetPayloadDuration (uint32_t size, WifiTxVector txVector, uint16_t frequency, MpduType mpdutype)
+WifiPhy::GetPayloadDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, MpduType mpdutype)
 {
   uint32_t totalAmpduSize;
   double totalAmpduNumSymbols;
-  return GetPayloadDuration (size, txVector, frequency, mpdutype, false, totalAmpduSize, totalAmpduNumSymbols);
+  return GetPayloadDuration (size, txVector, band, mpdutype, false, totalAmpduSize, totalAmpduNumSymbols);
 }
 
 Time
-WifiPhy::GetPayloadDuration (uint32_t size, WifiTxVector txVector, uint16_t frequency, MpduType mpdutype,
+WifiPhy::GetPayloadDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, MpduType mpdutype,
                              bool incFlag, uint32_t &totalAmpduSize, double &totalAmpduNumSymbols)
 {
   WifiMode payloadMode = txVector.GetMode ();
@@ -2368,7 +2490,7 @@
     case WIFI_MOD_CLASS_HT:
     case WIFI_MOD_CLASS_VHT:
       {
-        if (payloadMode.GetModulationClass () == WIFI_MOD_CLASS_HT && Is2_4Ghz (frequency)
+        if ((payloadMode.GetModulationClass () == WIFI_MOD_CLASS_HT) && (band == WIFI_PHY_BAND_2_4GHZ)
             && (mpdutype == NORMAL_MPDU || mpdutype == SINGLE_MPDU || mpdutype == LAST_MPDU_IN_AGGREGATE)) //at 2.4 GHz
           {
             return FemtoSeconds (static_cast<uint64_t> (numSymbols * symbolDuration.GetFemtoSeconds ())) + MicroSeconds (6);
@@ -2380,12 +2502,12 @@
       }
     case WIFI_MOD_CLASS_HE:
       {
-        if (Is2_4Ghz (frequency)
+        if ((band == WIFI_PHY_BAND_2_4GHZ)
             && ((mpdutype == NORMAL_MPDU || mpdutype == SINGLE_MPDU || mpdutype == LAST_MPDU_IN_AGGREGATE))) //at 2.4 GHz
           {
             return FemtoSeconds (static_cast<uint64_t> (numSymbols * symbolDuration.GetFemtoSeconds ())) + MicroSeconds (6);
           }
-        else //at 5 GHz
+        else //at 5 GHz or 6 GHz
           {
             return FemtoSeconds (static_cast<uint64_t> (numSymbols * symbolDuration.GetFemtoSeconds ()));
           }
@@ -2414,10 +2536,10 @@
 }
 
 Time
-WifiPhy::CalculateTxDuration (uint32_t size, WifiTxVector txVector, uint16_t frequency)
+WifiPhy::CalculateTxDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band)
 {
   Time duration = CalculatePhyPreambleAndHeaderDuration (txVector)
-    + GetPayloadDuration (size, txVector, frequency);
+    + GetPayloadDuration (size, txVector, band);
   return duration;
 }
 
@@ -2562,7 +2684,7 @@
       return;
     }
 
-  Time txDuration = CalculateTxDuration (psdu->GetSize (), txVector, GetFrequency ());
+  Time txDuration = CalculateTxDuration (psdu->GetSize (), txVector, GetPhyBand ());
   NS_ASSERT (txDuration.IsStrictlyPositive ());
 
   if ((m_currentEvent != 0) && (m_currentEvent->GetEndTime () > (Simulator::Now () + m_state->GetDelayUntilIdle ())))
@@ -2597,7 +2719,7 @@
   NotifyMonitorSniffTx (psdu, GetFrequency (), txVector);
   m_state->SwitchToTx (txDuration, psdu->GetPacket (), GetPowerDbm (txVector.GetTxPowerLevel ()), txVector);
 
-  Ptr<WifiPpdu> ppdu = Create<WifiPpdu> (psdu, txVector, txDuration, GetFrequency ());
+  Ptr<WifiPpdu> ppdu = Create<WifiPpdu> (psdu, txVector, txDuration, GetPhyBand ());
 
   if (m_wifiRadioEnergyModel != 0 && m_wifiRadioEnergyModel->GetMaximumTimeInState (WifiPhyState::TX) < txDuration)
     {
@@ -2888,6 +3010,11 @@
         }
       else
         {
+          m_statusPerMpdu.clear();
+          if (event->GetPsdu ()->GetNMpdus () > 1)
+            {
+              ScheduleEndOfMpdus (event);
+            }
           m_state->SwitchToRx (payloadDuration);
           m_endRxEvent = Simulator::Schedule (payloadDuration, &WifiPhy::EndReceive, this, event);
           NS_LOG_DEBUG ("Receiving PSDU");
@@ -2911,6 +3038,62 @@
 }
 
 void
+WifiPhy::ScheduleEndOfMpdus (Ptr<Event> event)
+{
+  NS_LOG_FUNCTION (this << *event);
+  Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
+  WifiTxVector txVector = event->GetTxVector ();
+  Time endOfMpduDuration = NanoSeconds (0);
+  Time relativeStart = NanoSeconds (0);
+  Time psduDuration = ppdu->GetTxDuration () - CalculatePhyPreambleAndHeaderDuration (txVector);
+  Time remainingAmpduDuration = psduDuration;
+  MpduType mpdutype = FIRST_MPDU_IN_AGGREGATE;
+  uint32_t totalAmpduSize = 0;
+  double totalAmpduNumSymbols = 0.0;
+  Ptr<const WifiPsdu> psdu = event->GetPsdu ();
+  size_t nMpdus = psdu->GetNMpdus ();
+  auto mpdu = psdu->begin ();
+  for (size_t i = 0; i < nMpdus && mpdu != psdu->end (); ++mpdu)
+    {
+      Time mpduDuration = GetPayloadDuration (psdu->GetAmpduSubframeSize (i), txVector,
+                                              GetPhyBand (), mpdutype, true, totalAmpduSize, totalAmpduNumSymbols);
+
+      remainingAmpduDuration -= mpduDuration;
+      if (i == (nMpdus - 1) && !remainingAmpduDuration.IsZero ()) //no more MPDU coming
+        {
+          mpduDuration += remainingAmpduDuration; //apply a correction just in case rounding had induced slight shift
+        }
+
+      endOfMpduDuration += mpduDuration;
+      m_endOfMpduEvents.push_back (Simulator::Schedule (endOfMpduDuration, &WifiPhy::EndOfMpdu, this, event, Create<WifiPsdu> (*mpdu, false), i, relativeStart, mpduDuration));
+
+      //Prepare next iteration
+      ++i;
+      relativeStart += mpduDuration;
+      mpdutype = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
+    }
+}
+
+void
+WifiPhy::EndOfMpdu (Ptr<Event> event, Ptr<const WifiPsdu> psdu, size_t mpduIndex, Time relativeStart, Time mpduDuration)
+{
+  NS_LOG_FUNCTION (this << *event << mpduIndex << relativeStart << mpduDuration);
+  Ptr<const WifiPpdu> ppdu = event->GetPpdu ();
+
+  std::pair<bool, SignalNoiseDbm> rxInfo = GetReceptionStatus (psdu, event, relativeStart, mpduDuration);
+  NS_LOG_DEBUG ("Extracted MPDU #" << mpduIndex << ": duration: " << mpduDuration.GetNanoSeconds () << "ns" <<
+                ", correct reception: " << rxInfo.first << ", Signal/Noise: " << rxInfo.second.signal << "/" << rxInfo.second.noise << "dBm");
+
+  m_signalNoise = rxInfo.second;
+  m_statusPerMpdu.push_back (rxInfo.first);
+
+  if (rxInfo.first)
+    {
+      m_state->ContinueRxNextMpdu (Copy (psdu), m_interference.CalculateSnr (event), event->GetTxVector ());
+    }
+}
+
+void
 WifiPhy::EndReceive (Ptr<Event> event)
 {
   Time psduDuration = event->GetEndTime () - event->GetStartTime ();
@@ -2918,62 +3101,23 @@
   NS_ASSERT (GetLastRxEndTime () == Simulator::Now ());
   NS_ASSERT (event->GetEndTime () == Simulator::Now ());
 
-  double snr = m_interference.CalculateSnr (event);
-  std::vector<bool> statusPerMpdu;
-  SignalNoiseDbm signalNoise;
-
   Ptr<const WifiPsdu> psdu = event->GetPsdu ();
-  Time relativeStart = NanoSeconds (0);
-  bool receptionOkAtLeastForOneMpdu = false;
-  std::pair<bool, SignalNoiseDbm> rxInfo;
-  WifiTxVector txVector = event->GetTxVector ();
-  size_t nMpdus = psdu->GetNMpdus ();
-  if (nMpdus > 1)
+  if (psdu->GetNMpdus () == 1)
     {
-      //Extract all MPDUs of the A-MPDU to compute per-MPDU PER stats
-      Time remainingAmpduDuration = psduDuration;
-      MpduType mpdutype = FIRST_MPDU_IN_AGGREGATE;
-      auto mpdu = psdu->begin ();
-      uint32_t totalAmpduSize = 0;
-      double totalAmpduNumSymbols = 0.0;
-      for (size_t i = 0; i < nMpdus && mpdu != psdu->end (); ++mpdu)
-        {
-          Time mpduDuration = GetPayloadDuration (psdu->GetAmpduSubframeSize (i), txVector,
-                                                  GetFrequency (), mpdutype, true, totalAmpduSize, totalAmpduNumSymbols);
-          remainingAmpduDuration -= mpduDuration;
-          if (i == (nMpdus - 1) && !remainingAmpduDuration.IsZero ()) //no more MPDU coming
-            {
-              mpduDuration += remainingAmpduDuration; //apply a correction just in case rounding had induced slight shift
-            }
-          rxInfo = GetReceptionStatus (Create<WifiPsdu> (*mpdu, false),
-                                       event, relativeStart, mpduDuration);
-          NS_LOG_DEBUG ("Extracted MPDU #" << i << ": duration: " << mpduDuration.GetNanoSeconds () << "ns" <<
-                        ", correct reception: " << rxInfo.first <<
-                        ", Signal/Noise: " << rxInfo.second.signal << "/" << rxInfo.second.noise << "dBm");
-          signalNoise = rxInfo.second; //same information for all MPDUs
-          statusPerMpdu.push_back (rxInfo.first);
-          receptionOkAtLeastForOneMpdu |= rxInfo.first;
-
-          //Prepare next iteration
-          ++i;
-          relativeStart += mpduDuration;
-          mpdutype = (i == (nMpdus - 1)) ? LAST_MPDU_IN_AGGREGATE : MIDDLE_MPDU_IN_AGGREGATE;
-        }
-    }
-  else
-    {
-      rxInfo = GetReceptionStatus (psdu, event, relativeStart, psduDuration);
-      signalNoise = rxInfo.second; //same information for all MPDUs
-      statusPerMpdu.push_back (rxInfo.first);
-      receptionOkAtLeastForOneMpdu = rxInfo.first;
+      //We do not enter here for A-MPDU since this is done in WifiPhy::EndOfMpdu
+      std::pair<bool, SignalNoiseDbm> rxInfo = GetReceptionStatus (psdu, event, NanoSeconds (0), psduDuration);
+      m_signalNoise = rxInfo.second;
+      m_statusPerMpdu.push_back (rxInfo.first);
     }
 
   NotifyRxEnd (psdu);
-
-  if (receptionOkAtLeastForOneMpdu)
+  double snr = m_interference.CalculateSnr (event);
+  if (std::count (m_statusPerMpdu.begin (), m_statusPerMpdu.end (), true))
     {
-      NotifyMonitorSniffRx (psdu, GetFrequency (), txVector, signalNoise, statusPerMpdu);
-      m_state->SwitchFromRxEndOk (Copy (psdu), snr, txVector, statusPerMpdu);
+      //At least one MPDU has been successfully received
+      WifiTxVector txVector = event->GetTxVector ();
+      NotifyMonitorSniffRx (psdu, GetFrequency (), txVector, m_signalNoise, m_statusPerMpdu);
+      m_state->SwitchFromRxEndOk (Copy (psdu), snr, txVector, m_statusPerMpdu);
     }
   else
     {
